// Leagcy Quadrature reader
/* A project that that will read and decode 4 or 5 quadrature inputs
 from a Legacy Ornamental Mill.
 Written by Brian C. Slater, starting on May 7, 2005
*/

/*This is the Quadrature reader for a asynchronous "4x decoder"
	It was shamelessly stolen from FGPAS4fun.com
	and then modified
*/
module Quad_Read(CLK_0, Count, Quad_A, Quad_B, Reset);

parameter BITS_Counted = 16;

input Quad_A;
input Quad_B;
input Reset;
input CLK_0;

output [BITS_Counted-1:0] Count;

// this is where the Quad signals get sliced, diced, and counted
reg [2:0] Quad_A_delayed, Quad_B_delayed;
always @(posedge CLK_0) Quad_A_delayed <= {Quad_A_delayed[1:0], Quad_A};
always @(posedge CLK_0) Quad_B_delayed <= {Quad_B_delayed[1:0], Quad_B};

wire Count_enable = Quad_A_delayed[1] ^ Quad_A_delayed[2] ^ Quad_B_delayed[1] ^ Quad_B_delayed[2];
wire Count_direction = Quad_A_delayed[1] ^ Quad_B_delayed[2];

reg [BITS_Counted-1:0] Count;
always @(posedge CLK_0)
begin
	Count<=Count+(Count_enable * (Count_direction *2-1)); 
	if (!Reset) Count <=0;
end
endmodule
